diff a/src/hotspot/share/utilities/ostream.cpp b/src/hotspot/share/utilities/ostream.cpp
--- a/src/hotspot/share/utilities/ostream.cpp
+++ b/src/hotspot/share/utilities/ostream.cpp
@@ -682,10 +682,14 @@
   FREE_C_HEAP_ARRAY(char, try_name);
   if (file->is_open()) {
     return file;
   }
 
+  if (RecordTraining) {
+    vm_exit_during_initialization("cannot create log file for RecordTraining mode: %s", try_name);
+  }
+
   // Try again to open the file in the temp directory.
   delete file;
   // Note: This feature is for maintainer use only.  No need for L10N.
   jio_printf("Warning:  Cannot open log file: %s\n", log_name);
   try_name = make_log_name(log_name, os::get_temp_directory());
@@ -737,42 +741,45 @@
              " process='%d' time_ms='" INT64_FORMAT "'",
              LOG_MAJOR_VERSION, LOG_MINOR_VERSION,
              os::current_process_id(), (int64_t)time_ms);
     // Write VM version header immediately.
     xs->head("vm_version");
-    xs->head("name"); xs->text("%s", VM_Version::vm_name()); xs->cr();
+    xs->head("name");  // FIXME: should be an elem attr, not head/tail pair
+    xs->log_only()->print_cr("%s", VM_Version::vm_name());
     xs->tail("name");
-    xs->head("release"); xs->text("%s", VM_Version::vm_release()); xs->cr();
+    xs->head("release");
+    xs->log_only()->print_cr("%s", VM_Version::vm_release());
     xs->tail("release");
-    xs->head("info"); xs->text("%s", VM_Version::internal_vm_info_string()); xs->cr();
+    xs->head("info");
+    xs->log_only()->print_cr("%s", VM_Version::internal_vm_info_string());
     xs->tail("info");
     xs->tail("vm_version");
     // Record information about the command-line invocation.
     xs->head("vm_arguments");  // Cf. Arguments::print_on()
     if (Arguments::num_jvm_flags() > 0) {
       xs->head("flags");
-      Arguments::print_jvm_flags_on(xs->text());
+      Arguments::print_jvm_flags_on(xs->log_only());
       xs->tail("flags");
     }
     if (Arguments::num_jvm_args() > 0) {
       xs->head("args");
-      Arguments::print_jvm_args_on(xs->text());
+      Arguments::print_jvm_args_on(xs->log_only());
       xs->tail("args");
     }
     if (Arguments::java_command() != nullptr) {
-      xs->head("command"); xs->text()->print_cr("%s", Arguments::java_command());
+      xs->head("command"); xs->log_only()->print_cr("%s", Arguments::java_command());
       xs->tail("command");
     }
     if (Arguments::sun_java_launcher() != nullptr) {
-      xs->head("launcher"); xs->text()->print_cr("%s", Arguments::sun_java_launcher());
+      xs->head("launcher"); xs->log_only()->print_cr("%s", Arguments::sun_java_launcher());
       xs->tail("launcher");
     }
     if (Arguments::system_properties() !=  nullptr) {
       xs->head("properties");
       // Print it as a java-style property list.
       // System properties don't generally contain newlines, so don't bother with unparsing.
-      outputStream *text = xs->text();
+      outputStream *text = xs->log_only();
       for (SystemProperty* p = Arguments::system_properties(); p != nullptr; p = p->next()) {
         assert(p->key() != nullptr, "p->key() is null");
         if (p->readable()) {
           // Print in two stages to avoid problems with long
           // keys/values.
@@ -787,10 +794,11 @@
     xs->tail("vm_arguments");
     // tty output per se is grouped under the <tty>...</tty> element.
     xs->head("tty");
     // All further non-markup text gets copied to the tty:
     xs->_text = this;  // requires friend declaration!
+    // (And xtty->log_only() remains as a back door to the non-tty log file.)
 }
 
 // finish_log() is called during normal VM shutdown. finish_log_on_error() is
 // called by ostream_abort() after a fatal error.
 //
diff a/src/hotspot/share/utilities/xmlstream.cpp b/src/hotspot/share/utilities/xmlstream.cpp
--- a/src/hotspot/share/utilities/xmlstream.cpp
+++ b/src/hotspot/share/utilities/xmlstream.cpp
@@ -30,25 +30,71 @@
 #include "oops/methodData.hpp"
 #include "oops/method.inline.hpp"
 #include "oops/oop.inline.hpp"
 #include "runtime/deoptimization.hpp"
 #include "runtime/handles.inline.hpp"
+#include "runtime/osThread.hpp"
 #include "runtime/vmOperations.hpp"
 #include "runtime/vmThread.hpp"
 #include "utilities/vmError.hpp"
 #include "utilities/xmlstream.hpp"
 
+// The XML stream is the contents of the LogFile (default hotspot_%p.log).
+// It is a superset of whatever might be displayed on the tty.
+// You can get to it by calls of the form xtty->...
+// Normal calls to tty->... just embed plain text among any markup
+// produced via the xtty API.
+// The xtty has sub-streams called xtty->text() and xtty->log_long().
+// These are ordinary output streams for writing unstructured text.
+// The format of this log file is both unstructured and constrained.
+//
+// Apart from possible race conditions, every line in the log file
+// is either an XML element (<tag ...>, or </tag>, or <tag .../>)
+// or is unstructured text.
+//
+// On any given line, if the first character is '<', then the last
+// character is '>' and the line consists of a single XML element,
+// which uses single quote '\'' to delimit any attribute values.
+// (The double-quote character '"' never appears, ever.)
+//
+// All other lines consist of unstructured text which is completely
+// free of the following characters: '<', '>', '&', '\'', '"'.  If
+// those characters are written to the tty (or to any other text
+// stream underlying the xtty), those characters, and no other
+// characters, are written as XML entities: "&lt;", "&gt;", "&amp;",
+// "&apos", "&quot".  There is no other use of the character '&'.
+//
+// The net effect is that you may select a range of tools to process
+// the marked-up logs, including XML parsers and simple line-oriented
+// Java or Unix tools.  The main concession you have to make to XML
+// is to convert the above five XML entities to single ASCII chars,
+// as you process attribute strings or unstructured text.
+//
+// It would be wise to ignore any XML tags that you do not recognize.
+// This can be done with grep, if you choose, because the log file
+// is line-structured.
+//
+// The log file collects the output from many contributing threads.
+// You should expect that an element of the form <writer thread='NNN'>
+// could appear almost anywhere, as the lines interleave.
+// It is straightforward to write a script to tease the log file
+// into thread-specific substreams.
+
 // Do not assert this condition if there's already another error reported.
 #define assert_if_no_error(cond, msg) \
   vmassert((cond) || VMError::is_error_reported(), msg)
+bool xmlStream::inside_attrs_or_error() {
+  return inside_attrs() || VMError::is_error_reported();
+}
 
 void xmlStream::initialize(outputStream* out) {
   _out = out;
   _last_flush = 0;
   _markup_state = BODY;
   _text_init._outer_xmlStream = this;
   _text = &_text_init;
+  _log_only = _text;
 
 #ifdef ASSERT
   _element_depth = 0;
   int   init_len = 100;
   char* init_buf = NEW_C_HEAP_ARRAY(char, init_len, mtInternal);
@@ -127,19 +173,30 @@
   va_start(ap, format);
   va_text(format, ap);
   va_end(ap);
 }
 
+// ------------------------------------------------------------------
+// Outputs XML attribute, with quotes and special characters quoted.
+void xmlStream::attr(const char* attr, const char* format, ...) {
+  va_list ap;
+  va_start(ap, format);
+  va_attr(attr, format, ap);
+  va_end(ap);
+}
+
 #define BUFLEN 2*K   /* max size of output of individual print methods */
 
 // ------------------------------------------------------------------
 void xmlStream::va_tag(bool push, const char* format, va_list ap) {
   assert_if_no_error(!inside_attrs(), "cannot print tag inside attrs");
   char buffer[BUFLEN];
   size_t len;
   const char* kind = do_vsnprintf(buffer, BUFLEN, format, ap, false, len);
   see_tag(kind, push);
+  // make sure all opening and/or closing tags begin in the first column
+  if (out()->position() > 0)  print_raw("\n");
   print_raw("<");
   write(kind, len);
   _markup_state = (push ? HEAD : ELEM);
 }
 
@@ -313,10 +370,12 @@
 
 // ------------------------------------------------------------------
 // Outputs "</kind>".
 void xmlStream::tail(const char* kind) {
   pop_tag(kind);
+  // make sure all opening and/or closing tags begin in the first column
+  if (out()->position() > 0)  print_raw("\n");
   print_raw("</");
   print_raw(kind);
   print_raw(">\n");
 }
 
@@ -374,27 +433,39 @@
 }
 PRAGMA_DIAG_POP
 
 // Output a timestamp attribute.
 void xmlStream::stamp() {
-  assert_if_no_error(inside_attrs(), "stamp must be an attribute");
+  assert(inside_attrs_or_error(), "stamp must be an attribute");
   print_raw(" stamp='");
   out()->stamp();
   print_raw("'");
 }
 
 
 // ------------------------------------------------------------------
 // Output a method attribute, in the form " method='pkg/cls name sig'".
 // This is used only when there is no ciMethod available.
-void xmlStream::method(Method* method) {
-  assert_if_no_error(inside_attrs(), "printing attributes");
+void xmlStream::method(Method* method, const char* pfx) {
+  assert(inside_attrs_or_error(), "printing attributes");
   if (method == nullptr)  return;
-  print_raw(" method='");
+  if (*pfx) {
+    print(" %smethod='", pfx);
+    method_text(method);
+    print_raw("'");
+    return;
+  }
+  print(" method='");
   method_text(method);
   print("' bytes='%d'", method->code_size());
   print(" count='%d'", method->invocation_count());
+  if (RecordTraining) {
+    // print stuff about this method's compilation history
+    print(" highest_comp_level='%d'", method->highest_comp_level());
+    nmethod* nm = method->code();
+    if (nm != nullptr)  print(" last_compile_id='%d'", nm->compile_id());
+  }
   int bec = method->backedge_count();
   if (bec != 0)  print(" backedge_count='%d'", bec);
   print(" iicount='%d'", method->interpreter_invocation_count());
   int throwouts = method->interpreter_throwout_count();
   if (throwouts != 0)  print(" throwouts='%d'", throwouts);
@@ -414,11 +485,11 @@
   }
 }
 
 void xmlStream::method_text(Method* method) {
   ResourceMark rm;
-  assert_if_no_error(inside_attrs(), "printing attributes");
+  assert(inside_attrs_or_error(), "printing attributes");
   if (method == nullptr)  return;
   text()->print("%s", method->method_holder()->external_name());
   print_raw(" ");  // " " is easier for tools to parse than "::"
   method->name()->print_symbol_on(text());
   print_raw(" ");  // separator
@@ -427,69 +498,131 @@
 
 
 // ------------------------------------------------------------------
 // Output a klass attribute, in the form " klass='pkg/cls'".
 // This is used only when there is no ciKlass available.
-void xmlStream::klass(Klass* klass) {
-  assert_if_no_error(inside_attrs(), "printing attributes");
+void xmlStream::klass(Klass* klass, const char* pfx) {
+  assert(inside_attrs_or_error(), "printing attributes");
   if (klass == nullptr) return;
-  print_raw(" klass='");
+  print(" %sklass='", pfx);
   klass_text(klass);
   print_raw("'");
+  if (klass->class_loader() != nullptr) {
+    loader(klass->class_loader(), pfx);
+  }
 }
 
 void xmlStream::klass_text(Klass* klass) {
-  assert_if_no_error(inside_attrs(), "printing attributes");
+  assert(inside_attrs_or_error(), "printing attributes");
   if (klass == nullptr) return;
   //klass->print_short_name(log->out());
   klass->name()->print_symbol_on(out());
+  if (klass->is_hidden()) {
+    out()->print(" //hidden");
+    // FIXME:  maybe hash the contents of its classfile
+  }
 }
 
-void xmlStream::name(const Symbol* name) {
-  assert_if_no_error(inside_attrs(), "printing attributes");
+void xmlStream::loader(oop cl, const char* pfx) {
+  assert(inside_attrs_or_error(), "printing attributes");
+  if (cl == nullptr) return;
+  print(" %sloader='", pfx);
+  loader_text(cl);
+  print_raw("'");
+}
+
+void xmlStream::loader_text(oop cl) {
+  assert(inside_attrs_or_error(), "printing attributes");
+  if (cl == nullptr) return;
+  oop id = java_lang_ClassLoader::nameAndId(cl);
+  if (id != nullptr)  string_text(id);
+}
+
+void xmlStream::name(const Symbol* name, const char* pfx) {
+  assert(inside_attrs_or_error(), "printing attributes");
   if (name == nullptr)  return;
-  print_raw(" name='");
-  name_text(name);
+  print(" %sname='", pfx);
+  symbol_text(name);
   print_raw("'");
 }
 
-void xmlStream::name_text(const Symbol* name) {
-  assert_if_no_error(inside_attrs(), "printing attributes");
+void xmlStream::signature(const Symbol* sig, const char* pfx) {
+  assert(inside_attrs_or_error(), "printing attributes");
+  if (sig == nullptr)  return;
+  print(" %ssignature='", pfx);
+  symbol_text(sig);
+  print_raw("'");
+}
+
+void xmlStream::symbol_text(const Symbol* name) {
+  assert(inside_attrs_or_error(), "printing attributes");
   if (name == nullptr)  return;
   //name->print_short_name(text());
-  name->print_symbol_on(text());
+  //name->print_symbol_on(text());  // this has odd escapes in it (\\x%04x)
+  const char* base = (const char*) name->base();
+  int len = name->utf8_length();
+  log_only()->write(base, len);
+}
+
+void xmlStream::string_text(oop str) {
+  assert(inside_attrs_or_error(), "printing attributes");
+  if (str == nullptr)  return;
+  if (!java_lang_String::is_instance(str)) {
+    print("*** not a string*** ");
+    str->print_value_on(log_only());
+    return;
+  }
+  ResourceMark rm;
+  log_only()->print_raw(java_lang_String::as_utf8_string(str));
+}
+
+void xmlStream::thread(Thread* t, const char* pfx) {
+  assert(inside_attrs_or_error(), "printing attributes");
+  intx tid = t == nullptr ? os::current_thread_id() : t->osthread()->thread_id();
+  guarantee(tid == (t == nullptr ? Thread::current() : t)->osthread()->thread_id(), "");
+  print(" %sthread='" INTX_FORMAT "'", pfx, tid);
 }
 
 void xmlStream::object(const char* attr, Handle x) {
-  assert_if_no_error(inside_attrs(), "printing attributes");
+  assert(inside_attrs_or_error(), "printing attributes");
   if (x == nullptr)  return;
   print_raw(" ");
   print_raw(attr);
   print_raw("='");
   object_text(x);
   print_raw("'");
 }
 
 void xmlStream::object_text(Handle x) {
-  assert_if_no_error(inside_attrs(), "printing attributes");
-  if (x == nullptr)  return;
-  x->print_value_on(text());
+  assert(inside_attrs_or_error(), "printing attributes");
+  if (x.is_null())  return;
+  if (java_lang_ClassLoader::is_instance(x())) {
+    print_raw("loader:");
+    loader_text(x());
+    return;
+  }
+  if (java_lang_String::is_instance(x())) {
+    print_raw("string:");
+    string_text(x());
+    return;
+  }
+  x->print_value_on(log_only());
 }
 
 
 void xmlStream::object(const char* attr, Metadata* x) {
-  assert_if_no_error(inside_attrs(), "printing attributes");
+  assert(inside_attrs_or_error(), "printing attributes");
   if (x == nullptr)  return;
   print_raw(" ");
   print_raw(attr);
   print_raw("='");
   object_text(x);
   print_raw("'");
 }
 
 void xmlStream::object_text(Metadata* x) {
-  assert_if_no_error(inside_attrs(), "printing attributes");
+  assert(inside_attrs_or_error(), "printing attributes");
   if (x == nullptr)  return;
   //x->print_value_on(text());
   if (x->is_method())
     method_text((Method*)x);
   else if (x->is_klass())
diff a/src/hotspot/share/utilities/xmlstream.hpp b/src/hotspot/share/utilities/xmlstream.hpp
--- a/src/hotspot/share/utilities/xmlstream.hpp
+++ b/src/hotspot/share/utilities/xmlstream.hpp
@@ -68,10 +68,11 @@
  protected:
   outputStream* _out;            // file stream by which it goes
   julong        _last_flush;     // last position of flush
   MarkupState   _markup_state;   // where in the elem/head/tail dance
   outputStream* _text;           // text stream
+  outputStream* _log_only;       // like text, except does not copy to the tty
   xmlTextStream _text_init;
 
   // for subclasses
   xmlStream() {}
   void initialize(outputStream* out);
@@ -99,10 +100,11 @@
 
   bool is_open() { return _out != nullptr; }
 
   // text output
   bool inside_attrs() { return _markup_state != BODY; }
+  bool inside_attrs_or_error();
 
   // flushing
   virtual void flush();  // flushes out, sets _last_flush = count()
   virtual void write(const char* s, size_t len);
   void    write_text(const char* s, size_t len);  // used by xmlTextStream
@@ -133,24 +135,45 @@
   void          text(const char* format, ...) ATTRIBUTE_PRINTF(2, 3);
   void       va_text(const char* format, va_list ap) ATTRIBUTE_PRINTF(2, 0) {
     text()->vprint(format, ap);
   }
 
+  // write attr with formatted contents
+  void          attr(const char* attr, const char* format, ...) ATTRIBUTE_PRINTF(3, 4);
+  void       va_attr(const char* attr, const char* format, va_list ap) ATTRIBUTE_PRINTF(3, 0) {
+    print_raw(" ");
+    print_raw(attr);
+    print_raw("='");
+    va_text(format, ap);
+    print_raw("='");
+  }
+
+  outputStream* log_only() { return _log_only; }
+  // report if a given random stream is really part of this XML stream
+  bool owns(outputStream* st) {
+    return st == this || st == _text || st == _log_only || st == _out;
+  }
+
   // commonly used XML attributes
   void          stamp();                 // stamp='1.234'
-  void          method(Method* m);       // method='k n s' ...
-  void          klass(Klass* k);         // klass='name'
-  void          name(const Symbol* s);   // name='name'
+  void          method(Method* m, const char* pfx=""); // method='k n s' ...
+  void          klass(Klass* k, const char* pfx="");   // klass='name'
+  void          loader(oop cl, const char* pfx="");   // loader='...'
+  void          name(const Symbol* s, const char* pfx="");   // name='n'
+  void          signature(const Symbol* s, const char* pfx="");   // signature='...'
   void          object(const char* attr, Metadata* val);
   void          object(const char* attr, Handle val);
+  void          thread(Thread* t = nullptr, const char* pfx=""); // thread='NNN'
 
   // print the text alone (sans ''):
   void          method_text(Method* m);
-  void          klass_text(Klass* k);         // klass='name'
-  void          name_text(const Symbol* s);   // name='name'
+  void          klass_text(Klass* k);         // java.lang.String
+  void          symbol_text(const Symbol* s);   // (utf8 bytes)...
+  void          loader_text(oop cl);
   void          object_text(Metadata* x);
   void          object_text(Handle x);
+  void          string_text(oop str);
 
   /*  Example uses:
 
       // Empty element, simple case.
       elem("X Y='Z'");          <X Y='Z'/> \n
@@ -180,8 +203,12 @@
 };
 
 // Standard log file, null if no logging is happening.
 extern xmlStream* xtty;
 
+static inline bool xtty_owns(outputStream* st) {
+  return xtty != nullptr && xtty->owns(st);
+}
+
 // Note:  If ::xtty != nullptr, ::tty == ::xtty->text().
 
 #endif // SHARE_UTILITIES_XMLSTREAM_HPP
diff a/src/hotspot/share/utilities/zipLibrary.cpp b/src/hotspot/share/utilities/zipLibrary.cpp
--- a/src/hotspot/share/utilities/zipLibrary.cpp
+++ b/src/hotspot/share/utilities/zipLibrary.cpp
@@ -34,18 +34,20 @@
  // Entry points in zip.dll for loading zip/jar file entries
 typedef void**(*ZIP_Open_t)(const char* name, char** pmsg);
 typedef void(*ZIP_Close_t)(jzfile* zip);
 typedef jzentry* (*ZIP_FindEntry_t)(jzfile* zip, const char* name, jint* sizeP, jint* nameLen);
 typedef jboolean(*ZIP_ReadEntry_t)(jzfile* zip, jzentry* entry, unsigned char* buf, char* namebuf);
+typedef void(*ZIP_FreeEntry_t)(jzfile *zip, jzentry *entry);
 typedef jint(*ZIP_CRC32_t)(jint crc, const jbyte* buf, jint len);
 typedef const char* (*ZIP_GZip_InitParams_t)(size_t, size_t*, size_t*, int);
 typedef size_t(*ZIP_GZip_Fully_t)(char*, size_t, char*, size_t, char*, size_t, int, char*, char const**);
 
 static ZIP_Open_t ZIP_Open = nullptr;
 static ZIP_Close_t ZIP_Close = nullptr;
 static ZIP_FindEntry_t ZIP_FindEntry = nullptr;
 static ZIP_ReadEntry_t ZIP_ReadEntry = nullptr;
+static ZIP_FreeEntry_t ZIP_FreeEntry = nullptr;
 static ZIP_CRC32_t ZIP_CRC32 = nullptr;
 static ZIP_GZip_InitParams_t ZIP_GZip_InitParams = nullptr;
 static ZIP_GZip_Fully_t ZIP_GZip_Fully = nullptr;
 
 static void* _zip_handle = nullptr;
@@ -74,10 +76,11 @@
   assert(_zip_handle != nullptr, "invariant");
   ZIP_Open = CAST_TO_FN_PTR(ZIP_Open_t, dll_lookup("ZIP_Open", path, vm_exit_on_failure));
   ZIP_Close = CAST_TO_FN_PTR(ZIP_Close_t, dll_lookup("ZIP_Close", path, vm_exit_on_failure));
   ZIP_FindEntry = CAST_TO_FN_PTR(ZIP_FindEntry_t, dll_lookup("ZIP_FindEntry", path, vm_exit_on_failure));
   ZIP_ReadEntry = CAST_TO_FN_PTR(ZIP_ReadEntry_t, dll_lookup("ZIP_ReadEntry", path, vm_exit_on_failure));
+  ZIP_FreeEntry = CAST_TO_FN_PTR(ZIP_FreeEntry_t, dll_lookup("ZIP_FreeEntry", path, vm_exit_on_failure));
   ZIP_CRC32 = CAST_TO_FN_PTR(ZIP_CRC32_t, dll_lookup("ZIP_CRC32", path, vm_exit_on_failure));
   // The following entry points are most likely optional from a zip library implementation perspective.
   // Hence no vm_exit on a resolution failure. Further refactorings should investigate this,
   // and if possible, streamline setting all entry points consistently.
   ZIP_GZip_InitParams = CAST_TO_FN_PTR(ZIP_GZip_InitParams_t, dll_lookup("ZIP_GZip_InitParams", path, false));
@@ -164,10 +167,16 @@
   initialize();
   assert(ZIP_ReadEntry != nullptr, "invariant");
   return ZIP_ReadEntry(zip, entry, buf, namebuf);
 }
 
+void ZipLibrary::free_entry(jzfile* zip, jzentry* entry) {
+  initialize();
+  assert(ZIP_FreeEntry != nullptr, "invariant");
+  ZIP_FreeEntry(zip, entry);
+}
+
 jint ZipLibrary::crc32(jint crc, const jbyte* buf, jint len) {
   initialize();
   assert(ZIP_CRC32 != nullptr, "invariant");
   return ZIP_CRC32(crc, buf, len);
 }
diff a/src/hotspot/share/utilities/zipLibrary.hpp b/src/hotspot/share/utilities/zipLibrary.hpp
--- a/src/hotspot/share/utilities/zipLibrary.hpp
+++ b/src/hotspot/share/utilities/zipLibrary.hpp
@@ -44,10 +44,11 @@
  public:
   static void** open(const char* name, char** pmsg);
   static void close(jzfile* zip);
   static jzentry* find_entry(jzfile* zip, const char* name, jint* sizeP, jint* nameLen);
   static jboolean read_entry(jzfile* zip, jzentry* entry, unsigned char* buf, char* namebuf);
+  static void free_entry(jzfile* zip, jzentry* entry);
   static jint crc32(jint crc, const jbyte* buf, jint len);
   static const char* init_params(size_t block_size, size_t* needed_out_size, size_t* needed_tmp_size, int level);
   static size_t compress(char* in, size_t in_size, char* out, size_t out_size, char* tmp, size_t tmp_size, int level, char* buf, const char** pmsg);
   static void* handle();
 };
diff a/src/java.base/share/classes/java/lang/Class.java b/src/java.base/share/classes/java/lang/Class.java
--- a/src/java.base/share/classes/java/lang/Class.java
+++ b/src/java.base/share/classes/java/lang/Class.java
@@ -460,10 +460,21 @@
     @CallerSensitiveAdapter
     private static Class<?> forName(String className, Class<?> caller)
             throws ClassNotFoundException {
         ClassLoader loader = (caller == null) ? ClassLoader.getSystemClassLoader()
                                               : ClassLoader.getClassLoader(caller);
+        if (loader instanceof BuiltinClassLoader bcl) {
+            if (bcl.usePositiveCache) {
+                Class<?> result = bcl.checkPositiveLookupCache(className);
+                if (result != null) {
+                    return result;
+                }
+            }
+            if (bcl.useNegativeCache && bcl.checkNegativeLookupCache(className)) {
+                throw new ClassNotFoundException(className);
+            }
+        }
         return forName0(className, true, loader, caller);
     }
 
     /**
      * Returns the {@code Class} object associated with the class or
@@ -540,10 +551,21 @@
      * @since     1.2
      */
     public static Class<?> forName(String name, boolean initialize, ClassLoader loader)
         throws ClassNotFoundException
     {
+        if (loader instanceof BuiltinClassLoader bcl) {
+            if (bcl.usePositiveCache) {
+                Class<?> result = bcl.checkPositiveLookupCache(name);
+                if (result != null) {
+                    return result;
+                }
+            }
+           if (bcl.useNegativeCache && bcl.checkNegativeLookupCache(name)) {
+                throw new ClassNotFoundException(name);
+            }
+        }
         return forName0(name, initialize, loader, null);
     }
 
     /** Called after security check for system loader access checks have been made. */
     private static native Class<?> forName0(String name, boolean initialize,
@@ -2783,12 +2805,12 @@
         // offset of Class.annotationData instance field
         private static final long annotationDataOffset
                 = unsafe.objectFieldOffset(Class.class, "annotationData");
 
         static <T> boolean casReflectionData(Class<?> clazz,
-                                             SoftReference<ReflectionData<T>> oldData,
-                                             SoftReference<ReflectionData<T>> newData) {
+                                             ReflectionData<T> oldData,
+                                             ReflectionData<T> newData) {
             return unsafe.compareAndSetReference(clazz, reflectionDataOffset, oldData, newData);
         }
 
         static boolean casAnnotationType(Class<?> clazz,
                                          AnnotationType oldType,
@@ -2832,45 +2854,41 @@
         ReflectionData(int redefinedCount) {
             this.redefinedCount = redefinedCount;
         }
     }
 
-    private transient volatile SoftReference<ReflectionData<T>> reflectionData;
+    private transient volatile ReflectionData<T> reflectionData;
 
     // Incremented by the VM on each call to JVM TI RedefineClasses()
     // that redefines this class or a superclass.
     private transient volatile int classRedefinedCount;
 
     // Lazily create and cache ReflectionData
     private ReflectionData<T> reflectionData() {
-        SoftReference<ReflectionData<T>> reflectionData = this.reflectionData;
+        ReflectionData<T> reflectionData = this.reflectionData;
         int classRedefinedCount = this.classRedefinedCount;
-        ReflectionData<T> rd;
         if (reflectionData != null &&
-            (rd = reflectionData.get()) != null &&
-            rd.redefinedCount == classRedefinedCount) {
-            return rd;
+            reflectionData.redefinedCount == classRedefinedCount) {
+            return reflectionData;
         }
         // else no SoftReference or cleared SoftReference or stale ReflectionData
         // -> create and replace new instance
         return newReflectionData(reflectionData, classRedefinedCount);
     }
 
-    private ReflectionData<T> newReflectionData(SoftReference<ReflectionData<T>> oldReflectionData,
+    private ReflectionData<T> newReflectionData(ReflectionData<T> oldReflectionData,
                                                 int classRedefinedCount) {
         while (true) {
             ReflectionData<T> rd = new ReflectionData<>(classRedefinedCount);
             // try to CAS it...
-            if (Atomic.casReflectionData(this, oldReflectionData, new SoftReference<>(rd))) {
+            if (Atomic.casReflectionData(this, oldReflectionData, rd)) {
                 return rd;
             }
             // else retry
             oldReflectionData = this.reflectionData;
             classRedefinedCount = this.classRedefinedCount;
-            if (oldReflectionData != null &&
-                (rd = oldReflectionData.get()) != null &&
-                rd.redefinedCount == classRedefinedCount) {
+            if (oldReflectionData != null && oldReflectionData.redefinedCount == classRedefinedCount) {
                 return rd;
             }
         }
     }
 
@@ -4174,6 +4192,55 @@
         Class<?> c = isArray() ? elementType() : this;
         return c.getClassAccessFlagsRaw0();
     }
 
     private native int getClassAccessFlagsRaw0();
+
+    // Support for "OLD" CDS workflow -- {
+    private static final int RD_PUBLIC_METHODS          = (1 <<  0);
+    private static final int RD_PUBLIC_FIELDS           = (1 <<  1);
+    private static final int RD_DECLARED_CTORS          = (1 <<  2);
+    private static final int RD_PUBLIC_CTORS = (1 <<  3);
+    private static final int RD_DECLARED_METHODS        = (1 <<  4);
+    private static final int RD_DECLARED_PUBLIC_METHODS = (1 <<  5);
+    private static final int RD_DECLARED_FIELDS         = (1 <<  6);
+    private static final int RD_DECLARED_PUBLIC_FIELDS  = (1 <<  7);
+    private static final int RD_DECLARED_INTERFACES     = (1 <<  8);
+    private static final int RD_DECLARED_SIMPLE_NAME    = (1 <<  9);
+    private static final int RD_DECLARED_CANONICAL_NAME = (1 << 10);
+    private static final int CLS_NAME = (1 << 10);
+
+
+    private int encodeReflectionData() {
+        int flags = CLS_NAME;
+        if (reflectionData != null) {
+            flags = (reflectionData.publicMethods         != null ? RD_PUBLIC_METHODS          : 0) |
+                    (reflectionData.publicFields          != null ? RD_PUBLIC_FIELDS           : 0) |
+                    (reflectionData.declaredConstructors  != null ? RD_DECLARED_CTORS          : 0) |
+                    (reflectionData.publicConstructors    != null ? RD_PUBLIC_CTORS            : 0) |
+                    (reflectionData.declaredMethods       != null ? RD_DECLARED_METHODS        : 0) |
+                    (reflectionData.declaredPublicMethods != null ? RD_DECLARED_PUBLIC_METHODS : 0) |
+                    (reflectionData.declaredFields        != null ? RD_DECLARED_FIELDS         : 0) |
+                    (reflectionData.declaredPublicFields  != null ? RD_DECLARED_PUBLIC_FIELDS  : 0) |
+                    (reflectionData.interfaces            != null ? RD_DECLARED_INTERFACES     : 0) |
+                    (reflectionData.simpleName            != null ? RD_DECLARED_SIMPLE_NAME    : 0) |
+                    (reflectionData.canonicalName         != null ? RD_DECLARED_CANONICAL_NAME : 0);
+        }
+        return flags;
+    }
+    private void generateReflectionData(int flags) {
+        if ((flags & CLS_NAME                  ) != 0) { getName();                             } // String name
+        if ((flags & RD_PUBLIC_METHODS         ) != 0) { privateGetPublicMethods();             } // Method[] publicMethods;
+        if ((flags & RD_PUBLIC_FIELDS          ) != 0) { privateGetPublicFields();              } // Field[] publicFields;
+        if ((flags & RD_DECLARED_CTORS         ) != 0) { privateGetDeclaredConstructors(false); } // Constructor<T>[] declaredConstructors;
+        if ((flags & RD_PUBLIC_CTORS           ) != 0) { privateGetDeclaredConstructors(true);  } // Constructor<T>[] publicConstructors;
+        if ((flags & RD_DECLARED_METHODS       ) != 0) { privateGetDeclaredMethods(false);      } // Method[] declaredMethods;
+        if ((flags & RD_DECLARED_PUBLIC_METHODS) != 0) { privateGetDeclaredMethods(true);       } // Method[] declaredPublicMethods;
+        if ((flags & RD_DECLARED_FIELDS        ) != 0) { privateGetDeclaredFields(false);       } // Field[] declaredFields;
+        if ((flags & RD_DECLARED_PUBLIC_FIELDS ) != 0) { privateGetDeclaredFields(true);        } // Field[] declaredPublicFields;
+        if ((flags & RD_DECLARED_INTERFACES    ) != 0) { getInterfaces(false);                  } // Class<?>[] interfaces;
+        if ((flags & RD_DECLARED_SIMPLE_NAME   ) != 0) { getSimpleName();                       } // String simpleName;
+        if ((flags & RD_DECLARED_CANONICAL_NAME) != 0) { getCanonicalName();                    } // String canonicalName;
+    }
+
+    // -- }
 }
